#include <Common.h>
#include <System/SysAll.h>
#include <UI/UIAll.h>

CharPtr StrLToA (CharPtr lpStr, Long lNum)
{
    Boolean bNeg=false;
    CharPtr ptr1, ptr2;
    Char ch;

    if (lNum < 0)
    {
        bNeg = true;
        lNum *= -1;
    }

    ptr1 = lpStr;
    ptr2 = lpStr;
    do
    {
        *ptr1++ = (lNum % 10) + '0';
        lNum /= 10;
    } while (lNum);
    if (bNeg)
        *ptr1++ = '-';
    *ptr1-- = '\0';
    while (ptr1 > ptr2)
    {
        ch = *ptr1;
        *ptr1-- = *ptr2;
        *ptr2++ = ch;
    }

    return lpStr;
}

Long StrAToL (CharPtr lpStr)
{
    Long lResult = 0;
    Boolean bNeg = false;

    if (*lpStr == '+')
        lpStr++;
    else if (*lpStr == '-')
    {
        lpStr++;
        bNeg = true;
    }
    while (*lpStr)
    {
        lResult *= 10;
        lResult += *lpStr++ - '0';
    }
    if (bNeg)
        lResult *= -1;

    return lResult;
}

void QShuffle (BytePtr base, Int numOfElements, Int width)
{
	BytePtr ptr1, ptr2;
    Byte ch;
	Int i, pos;

	while (numOfElements)
	{
		pos = SysRandom(0) % numOfElements--;
		if (pos == numOfElements) continue;
		ptr1 = (BytePtr)(base + pos * width);
		ptr2 = (BytePtr)(base + numOfElements * width);
		i = width;
		while (i--)
		{
			ch = *ptr1;
			*ptr1++ = *ptr2;
			*ptr2++ = ch;
		}
	}
}

void InitPopup (FormPtr fpForm, Word wTriggerId, Word wListId, Int iCurrent)
{
    CharPtr cpPtr;

    cpPtr = LstGetSelectionText(FrmGetObjectPtr(fpForm, 
        FrmGetObjectIndex(fpForm, wListId)), iCurrent);
    if (!cpPtr)
        cpPtr = "";
    FrmCopyLabel(fpForm, wTriggerId, cpPtr);
}

Int SelectPopup (FormPtr fpForm, Word wTriggerId, Word wListId, Int iCurrent)
{
    ListPtr lpPopup = FrmGetObjectPtr(fpForm, FrmGetObjectIndex(fpForm, wListId));
    Word iSelect;

    LstSetSelection(lpPopup, iCurrent);
    LstPopupList(lpPopup);
    iSelect = LstGetSelection( lpPopup );
    if( iSelect != noListSelection )
    {
        iCurrent = iSelect;
        FrmHideObject(fpForm, FrmGetObjectIndex(fpForm, wTriggerId));
        FrmCopyLabel(fpForm, wTriggerId, LstGetSelectionText(lpPopup, iCurrent));
        FrmShowObject(fpForm, FrmGetObjectIndex(fpForm, wTriggerId));
    }

    return iCurrent;
}

VoidHand SetField (FormPtr fpForm, Word wFieldId, ULong ulMaxChars, CharPtr cpText)
{
    FieldPtr fpField;
    VoidHand hNewHandle, hOldHandle;

    fpField = FrmGetObjectPtr(fpForm, FrmGetObjectIndex(fpForm, wFieldId));
    hNewHandle = MemHandleNew(ulMaxChars+1);
    if (hNewHandle)
    {
        hOldHandle = (VoidHand)FldGetTextHandle(fpField);
        if (cpText)
        {
            StrCopy(MemHandleLock(hNewHandle), cpText);
            MemHandleUnlock(hNewHandle);
        }
        else
        {
            ULong ulOldSize;

            if (hOldHandle)
            {
                ulOldSize = MemHandleSize(hOldHandle);
                if (ulOldSize > 0)
                    ulOldSize--;
                MemMove(MemHandleLock(hNewHandle), MemHandleLock(hOldHandle),
                    (ulMaxChars < ulOldSize) ? ulMaxChars : ulOldSize);
                MemHandleUnlock(hNewHandle);
                MemHandleUnlock(hOldHandle);
            }
        }
        FldSetMaxChars(fpField, ulMaxChars);
        FldSetTextHandle(fpField, (Handle)hNewHandle);

        if (hOldHandle)
            MemHandleFree(hOldHandle);
    }

    return hNewHandle;
}
