#include <Common.h>
#include <System/SysAll.h>
#include <UI/UIAll.h>

#include "PalmTech.h"
#include "Resource.h"
#include "Misc.h"
#include "About.h"
#include "CritHit.h"
#include "HitLoc.h"

#define PalmTechAppID            'PmTk'
#define PalmTechDBType           'Data'

Int StartApplication(void);
void StopApplication(void);
Boolean OpenDatabase(void);
Boolean CloseDatabase(void);
void EventLoop(void);

Boolean MainProc(EventPtr event);

void RollDice ();
void NextPage ();
void PrevPage ();
void ShowPage (Word wPage);
void ChangeCurrent (Word wId);
void GetButton (Word wId, DieRollPtr drPtr);
void SetButton (Word wId, DieRollPtr drPtr);
void CustomizeButton (Word wId);
void CheckCompare (DieRoll dr, Long lResult);

Boolean Initialize ();
Boolean Deinitialize ();

Int BestCompare (void *ptr1, void *ptr2, Long other, SortRecordInfoPtr, SortRecordInfoPtr, VoidHand appInfoH);
//Int BestCompare (VoidPtr ptr1, VoidPtr ptr2, Long other);

DmOpenRef PalmTechDB;
Char PalmTechDBName[] = "PalmTechDB";

/*
DieRollPtr g_drPages;
DieRoll g_drCurrent, g_drCustom;
Word g_wCurrentPage, g_wMaxPages, g_wCustomButton;
Boolean g_bDoCustom;
VoidHand hTitle, hNumber, hDie, hModifier;
VoidHand hBest, hCompare1, hCompare2;
Char g_szResultBuffer [50], g_szCurrentBuffer [50];
Char g_szButtonBuffer[NUM_BUTTONS * (MAX_TITLE_LEN+1)];
ControlPtr g_cpResultButton, g_cpCurrentBuffer;
*/
SoundNote sound0 [] =
{
    440, 75,
    0, 0
};
SoundNote sound1 [] =
{
    440, 75,
    660, 75,
    0, 0
};
SoundNote sound2 [] =
{
    660, 75,
    440, 75,
    0, 0
};
SoundNote sound3 [] =
{
    350, 125,
    350, 125,
    350, 125,
    280, 500,
    0, 0
};
SoundNote sound4 [] =
{
    440, 20,
    660, 20,
    440, 20,
    660, 20,
    0, 0
};
SoundNotePtr sounds [] = 
{
    sound0,
    sound1,
    sound2,
    sound3,
    sound4,
    0
};

DWord  PilotMain (Word cmd, Ptr cmdPBP, Word launchFlags)
{
    Int error;

    if (cmd == sysAppLaunchCmdNormalLaunch)
    {
        error = StartApplication();	// Application start code
        if (error) return error;

        EventLoop();	// Event loop

        StopApplication ();	// Application stop code
    }
    return 0;
}

Int StartApplication(void)
{
    Int error;

    error = Initialize();
    if (error) return error;
    error = OpenDatabase();
    if (error) return error;

//    FrmGotoForm(IDF_MAIN);
    FrmGotoForm(IDF_HIT_LOCATION);
}


void StopApplication(void)
{
    CloseDatabase();
    Deinitialize();
}

Boolean OpenDatabase(void)
{
/*    UInt index;
    VoidHand RecHandle;
    Ptr RecPointer;
    ULong ulLength;

    ulLength = (ULong)sizeof(DieRoll) * (ULong)g_wMaxPages * (ULong)NUM_BUTTONS;

    PalmTechDB = DmOpenDatabaseByTypeCreator(PalmTechDBType, PalmTechAppID, dmModeReadWrite);
    if (!PalmTechDB) 
    {
        if (DmCreateDatabase(0, PalmTechDBName, PalmTechAppID, PalmTechDBType, false)) 
            return 1;
        PalmTechDB = DmOpenDatabaseByTypeCreator(PalmTechDBType, PalmTechAppID, dmModeReadWrite);

        index = 0;

        // Write the prefs
        RecHandle = DmNewRecord(PalmTechDB, &index, sizeof(Prefs) + ulLength);
        RecPointer = MemHandleLock(RecHandle);
        DmWrite(RecPointer, 0, &g_prefs, sizeof(Prefs));
        DmWrite(RecPointer, sizeof(Prefs), g_drPages, ulLength);
        MemHandleUnlock(RecHandle); 
        DmReleaseRecord(PalmTechDB, index, true);  
    }
    else
    {
        Word wOldPrefSize;

        index = 0;

        RecHandle = DmQueryRecord(PalmTechDB, index);
        RecPointer = MemHandleLock(RecHandle);
        MemMove(&wOldPrefSize, RecPointer, sizeof(Word));
        MemMove(&g_prefs, RecPointer, (sizeof(Prefs) < wOldPrefSize) ? sizeof(Prefs) : wOldPrefSize);
        MemMove(g_drPages, (RecPointer+wOldPrefSize), ulLength);
        MemHandleUnlock(RecHandle); 
        DmReleaseRecord(PalmTechDB, index, false);  
    }
*/
    return 0;
}

Boolean CloseDatabase()
{
/*
    UInt index;
    VoidHand RecHandle;
    Ptr RecPointer;
    ULong ulLength;

    ulLength = (ULong)sizeof(DieRoll) * (ULong)g_wMaxPages * (ULong)NUM_BUTTONS;

    // Remove the records
    DmRemoveRecord(PalmTechDB, 0);

    index = 0;

    // Write the prefs
    RecHandle = DmNewRecord(PalmTechDB, &index, sizeof(Prefs) + ulLength);
    RecPointer = MemHandleLock(RecHandle);
    DmWrite(RecPointer, 0, &g_prefs, sizeof(Prefs));
    DmWrite(RecPointer, sizeof(Prefs), g_drPages, ulLength);
    MemHandleUnlock(RecHandle); 
    DmReleaseRecord(PalmTechDB, index, true);  

    DmCloseDatabase(PalmTechDB);
*/
    return 0;
}

void EventLoop(void)
{
    short err;
    Int formID;
    FormPtr fpForm;
    EventType event;

    do
    {

        EvtGetEvent(&event, -1);

        if (SysHandleEvent(&event)) continue;
        if (MenuHandleEvent((void *)0, &event, &err)) continue;

        if (event.eType == frmLoadEvent)
        {
            formID = event.data.frmLoad.formID;
            fpForm = FrmInitForm(formID);
            FrmSetActiveForm(fpForm);
            switch (formID) 
            {
                case IDF_MAIN:
                    FrmSetEventHandler(fpForm, (FormEventHandlerPtr) MainProc);
                    break;
                case IDF_CRITICAL_HIT:
                    FrmSetEventHandler(fpForm, (FormEventHandlerPtr) CriticalHitProc);
                    break;
                case IDF_HIT_LOCATION:
                    FrmSetEventHandler(fpForm, (FormEventHandlerPtr) HitLocationProc);
                    break;
                case IDF_ABOUT:
                    FrmSetEventHandler(fpForm, (FormEventHandlerPtr) AboutProc);
                    break;
            }
        }
        FrmDispatchEvent(&event);
    } while(event.eType != appStopEvent);
}

Boolean MainProc(EventPtr event)
{
    Int iHandled = 0;

    switch (event->eType) 
    {
        case frmOpenEvent:
        {
            FormPtr fpForm;

            fpForm = FrmGetActiveForm();
            FrmDrawForm(fpForm);
            iHandled = 1;
            break;
        }
    
        case ctlSelectEvent:  // A control button was pressed and released.
            switch (event->data.ctlEnter.controlID)
            {
                case IDC_BUTTON_ROLL:
                    break;
            }
            iHandled = 1;
            break;

        case menuEvent:
            switch (event->data.menu.itemID)
            {
                default:
                    HandleCommonMenu (event->data.menu.itemID);
            }
            iHandled = 1;
            break;
    }
    return iHandled;
}

Int BestCompare (VoidPtr ptr1, VoidPtr ptr2, Long other, SortRecordInfoPtr sptr1, SortRecordInfoPtr sptr2, VoidHand appInfoH)
//Int BestCompare (VoidPtr ptr1, VoidPtr ptr2, Long other)
{
    return (*((IntPtr)ptr2) - *((IntPtr)ptr1));
}

Long RollDie (DieRoll dr)
{
    Long lResult = (Long)dr.iModifier;

    if ((dr.iDie > 0) && (dr.iNumber > 0))
    {
        if ((dr.iBest > 0) && (dr.iBest < dr.iNumber))
        {
            IntPtr pBest;
            Int iTemp;

            pBest = (IntPtr)MemPtrNew(dr.iNumber * sizeof(Int));
            for (iTemp=0; iTemp<dr.iNumber; iTemp++)
                pBest[iTemp] = (SysRandom(0) % dr.iDie) + 1;

            // With the check above dr.iNumber must be > 1
            SysQSort(
                (BytePtr)pBest, 
                dr.iNumber,
                sizeof(Int),
                BestCompare, 
                0);

            for (iTemp=0; iTemp<dr.iBest; iTemp++)
                lResult += pBest[iTemp];
            MemPtrFree(pBest);
        }
        else
        {
            while (dr.iNumber--)
            {
                lResult += (Long)(SysRandom(0) % dr.iDie) + 1;
            }
        }
    }

    return lResult;
}

Boolean Initialize ()
{
    return 0;
}

Boolean Deinitialize ()
{
    return 0;
}

Int HandleCommonMenu (Word wId)
{
    Int iHandled = 1;

    switch (wId)
    {
        case IDM_INFO_ABOUT:
            FrmPopupForm(IDF_ABOUT);
            break;
        case IDM_TOOLS_CRITICAL_HIT:
            FrmGotoForm(IDF_CRITICAL_HIT);
            break;
        case IDM_TOOLS_HIT_LOCATION:
            FrmGotoForm(IDF_HIT_LOCATION);
            break;
    }

    return iHandled;
}

void GotoNextForm ()
{
    Word wCurrentForm;

    wCurrentForm = FrmGetActiveFormID() + 1;
    if (wCurrentForm > IDF_CRITICAL_HIT)
        wCurrentForm = IDF_HIT_LOCATION;

    FrmGotoForm(wCurrentForm);
}

void GotoPrevForm ()
{
    Word wCurrentForm;

    wCurrentForm = FrmGetActiveFormID() - 1;
    if (wCurrentForm < IDF_HIT_LOCATION)
        wCurrentForm = IDF_CRITICAL_HIT;

    FrmGotoForm(wCurrentForm);
}
